<template>
    <Page class="page">
        <ActionBar class="action" title="Camera">
            <NavigationButton text="Back!" android.systemIcon="ic_menu_back" @tap="goBack()" />
        </ActionBar>
        <GridLayout rows="auto,*,*">
            <ScrollView>
                    <StackLayout>
                        <Button v-show="!processing" :text="'\uf030'+' Generar evidencia'" class="button btn btn-primary fa" marginTop="20" @tap="tomarFoto"></Button>
                        <Label 
                        text="Galeria de evidencias" 
                        class="boring"
                        :style="{'text-align': 'center', 'font-size': '18px'}" 
                        textWrap="true"
                        backgroundColor="#ffffff">
                        </Label>
                        <Label
                            v-show="!processing"
                            v-if="itemList.length == 0"
                            text="Sin fotos aun. !!!"
                            textWrap="true"
                            :style="{'text-align': 'center'}"
                            backgroundColor="#ffffff">
                        </Label>
                        <RadListView 
                        v-if="itemList.length != 0"
                        for="item in itemList"
                        layout="grid"
                        gridSpanCount="3"
                        backgroundColor="rgba(255, 255, 255, 0.7)"
                        height="450dpi"
                        @itemTap="onItemTap">
                            <v-template>
                                <StackLayout class="item">
                                    <GridLayout rows="auto,auto">
                                        <Image :src="item.foto" stretch="fill"/>
                                        <Label
                                        :text="'Descripcion:\n'+item.nombre"
                                        textWrap="true"
                                        :style="{'text-align': 'center'}"
                                        backgroundColor="rgba(255, 255, 255, 0.7)"
                                        row="1">
                                        </Label>
                                    </GridLayout>
                                </StackLayout>
                            </v-template>
                        </RadListView>
                    </StackLayout>
            </ScrollView>
            <ActivityIndicator :busy="processing" color="#7d00cc" row="0" rowSpan="3"></ActivityIndicator>   
        </GridLayout>         
	</Page>
</template>

<script>
import ListPage from '../../pages/ListPage';
import IncidencesPage from '../../pages/IncidencesPage';
import * as camera from "nativescript-camera";
import store from '../../store';
import { urlApi } from '../../main.js';
import {ImageSource} from "tns-core-modules/image-source";
import axios from 'axios';
import ModalDeleteFoto from './ModalDeleteFoto';

export default {
    props:['id'],
    data() {
        return {
            processing: false,
            itemList: [],
            isAvailable: Boolean
        };
    },
    created(){
        this.obtenerFotos();
    },
    computed:{
        page(){
            return store.getters.getPage;
        }
    },
    methods: {
        tomarFoto() {
            // See the options at https://github.com/NativeScript/nativescript-camera#using-the-options-to-take-memory-efficient-picture
            // for more information on how to customize the pictures you take.
            camera.takePicture({ width: 300, height: 300, keepAspectRatio: true })
                .then(imageAsset => {
                    let source = new ImageSource();
                    let pictureFromCamera = imageAsset;
                    source.fromAsset(imageAsset).then(res => {
                        let base64 = res.toBase64String("png");
                        let pictureBase64 = "data:image/png;base64," + base64;
                        let nombre = 'evidencia_'+(Math.floor((Math.random() * 5000) + 100))+'.png';
                        
                        this.processing = true;
                        axios.post(urlApi+`/api/v1/mtto/photos-logs/${this.id}/add-photo`, {
                            nombre: nombre,
                            foto: pictureBase64
                        })
                        .then(data => {
                            console.log('imagen guardada');    
                            this.obtenerFotos();                
                        })
                        .catch(err => {
                            console.log("Error -> " + err.message);
                        });
                    }).catch(err => {
                        console.log("Error -> " + err.message);
                    });
                })
                .catch(err => {
                    console.log("Error -> " + err.message);
                });
        },
        obtenerFotos(){
            this.processing = true;
            axios.get(urlApi+`/api/v1/mtto/mantenimiento/logs/${this.id}/trackingPhotos`)
            .then(data => {
                this.processing = false;
                this.itemList = data.data;                    
                // 
            })
            .catch(err => {
                console.log("Error -> " + err.message);
            });
        },
        onItemTap({ item }){
            this.$showModal(ModalDeleteFoto, {
                props: {item:item}
            }).then(data => {
                if(data)
                    this.obtenerFotos();
            });
        },
        goBack(){
            this.$navigateTo(ListPage);
        }
    }
}
</script>

<style scoped>
    .item{
		margin: 10 10 10 10;
	}

    .button{
        margin-bottom: 10px;
        display: inline-block;
        text-decoration: none;
        font-weight: bold;
        padding: 60px 60px;
        background-color: #7d00cc;
    }
</style>
